// Listing9-8a.cpp
//
// This program generates the state machine
// code that processes digits two at a time.

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


const char *stateTable[65536];

inline int isDelim( char c )
{
	switch( c )
	{
		case 0:
		case '\n':
		case '\r':
		case '\t':
		case ' ':
		case ',':
		case ':':
		case ';':
			return 1;
	}
	return 0;
}

int main(void)
{
	// Initialize the stateTable with illegal character
	// entries:
	
	for( int i=0; i<65536;++i )
	{
		stateTable[i] = "illegal";
	}
	
	// Emit code for labels of the
	// form "_nn" where 'n' is a
	// single decimal digit.
	
	for( unsigned int first=0; first <= 0xff; ++first )
	{
		for( unsigned int second = 0; second <= 0xff; ++second )
		{
			if( isdigit(first) && isdigit(second) )
			{
				char *item = (char *)malloc(8);
				sprintf( item, "_%c%c", first, second );
				stateTable[ first*256+second ] = item; 
			}
			else if( first == '_' && isdigit( second ) )
			{
				char *item = (char *)malloc(8);
				sprintf( item, "_%c", second );
				stateTable[ first*256+second ] = item; 
			}
			else if( second == '_' && isdigit( first ) )
			{
				char *item = (char *)malloc(8);
				sprintf( item, "_%c", first );
				stateTable[ first*256+second ] = item; 
			}
			else if( isdigit( first ) && isDelim( second ))
			{
				char *item = (char *)malloc(16);
				sprintf( item, "_%cDelimiter", first );
				stateTable[ first*256+second ] = item; 
			}
			else if( isDelim( first ))
			{
				char *item = (char *)malloc(16);
				sprintf( item, "delimiter", first );
				stateTable[ first*256+second ] = item; 
			}
		}
	}
	
	for( int i=0; i < 8192; ++i )
	{
		printf
		( 
			"\t.word\t%s, %s,\t%s,\t%s,\t%s,\t%s,\t%s,\t%s\n",
			stateTable[ i*8 + 0 ],		
			stateTable[ i*8 + 1 ],		
			stateTable[ i*8 + 2 ],		
			stateTable[ i*8 + 3 ],		
			stateTable[ i*8 + 4 ],		
			stateTable[ i*8 + 5 ],		
			stateTable[ i*8 + 6 ],		
			stateTable[ i*8 + 7 ]
		);		
	}
}
